
#include "52-Driver.h"



//************************
//˵
//************************

#define DATA_BUS P1


sbit int0=P3^2;
sbit wait=P3^3;


sbit  rst=P2^5;
sbit  rs=P2^4;
sbit  cs=P2^3;
sbit  wr=P2^2;
sbit  rd=P2^1;
sbit  led=P2^0;






//==============================================================================
//Subroutine:	Delay2us
//==============================================================================
void Delay2us(uchar Counter)
{ 
while(--Counter);
}

//==============================================================================
//Subroutine:	Delay100us
//==============================================================================
void Delay100us(uchar Counter)
{
	while(Counter--)
	{	Delay2us(100);
	}
}

//==============================================================================
//Subroutine:	Delay1ms
//==============================================================================
void Delay1ms(uchar Counter)
{
	while(Counter--)
	{	Delay100us(11);			
	}
}

//==============================================================================
//Subroutine:	Delay10ms
//==============================================================================
void Delay10ms(uchar Counter)
{
	while(Counter--)
	{	Delay1ms(11);			
	}
}  

//==============================================================================
//Subroutine:	Delay100ms
//==============================================================================
void Delay100ms(uchar Counter)
{
	while(Counter--)
	{	Delay1ms(101);			
	}
}




void LCD_CmdWrite(uchar cmd) // Command Write
{ 
cs = 0;
rs = 1;
DATA_BUS = cmd;
wr = 0;
wr = 1;
cs= 1;
DATA_BUS = 0xff;
rs = 0;
}

uchar LCD_CmdRead(void) // Command ReadRead Register
{
uchar Data;
cs = 0;
rs= 1;
wr = 1;
rd = 0;
Data = DATA_BUS;
rd = 1;
cs = 1;
DATA_BUS = 0xff;
rs = 0;
return Data;
}

void LCD_DataWrite(uchar Data) // Data Write
{
cs = 0;
rs = 0;
DATA_BUS = Data;
wr = 0;
wr = 1;
cs = 1;
DATA_BUS = 0xff;
rs = 1;
}

uchar LCD_StatusRead(void) // Read Status Register
{
uchar Data;
cs = 0;
rs= 1;
wr = 1;
rd = 0;
Data = DATA_BUS;
rd = 1;
cs= 1;
DATA_BUS = 0xff;
rs = 0;
return Data;
}

uchar LCD_DataRead(void) // Data Read
{
uchar Data;
wr = 1;
cs = 0;
rs = 0;
rd = 0;
Data = DATA_BUS;
rd = 1;
cs = 1;
rs = 1;
return Data;
}

// ========== æCheck Busy ӳ ===========
void Chk_Busy(void)
{ uchar temp;
do
{ temp=LCD_StatusRead();
} while((temp&0x80)==0x80);
}


void Chk_Busy_BTE(void)
{
	uchar temp;
   	
	do
	{
     temp=LCD_StatusRead();
	}while((temp&0x40)==0x40);	   
}	

// ========== Hardware Reset (RA8870)===========
void LCDMode_Reset(void)
{ 
rst = 0;
Delay100ms(1);
rst = 1;
Delay100ms(1);
Chk_Busy();
}
