
#include "OCM480272-subroutine.h"


#include "8.h" //ɫ
#include "wait_l.h" //ͼι


/******************************************************************************/
//غο	  													  */
/******************************************************************************/

uint X1,Y1,X2,Y2,X3,Y3,X4,Y4;

void MidValueCalculate(void)
{
 if (X2>X3)
	{
		if (X3>X4)
		{X1=X3;}	
		else
		{
		   if (X2>X4)
			{ X1=X4;}
			else	
			{ X1=X2;}
		}		
	}			
 else
	{
		if (X3<X4)
		{ X1=X3;}	
		else
		{
			if (X2<X4)
			{ X1=X4;}
			else	
			{ X1=X2; }
		}	
	}
			
 if (Y2>Y3)
	{
		if (Y3>Y4)
		{Y1=Y3;}	
		else
		{
		   if (Y2>Y4)
			{ Y1=Y4;}
			else	
			{ Y1=Y2;}
		}		
	}			
 else
	{
		if (Y3<Y4)
		{ Y1=Y3;}	
		else
		{
			if (Y2<Y4)
			{ Y1=Y4;}
			else	
			{ Y1=Y2; }
		}									
   }
 }

 //==============================================================================
//Subroutine:	Detect_TP_X_Y coordinate 
//==============================================================================
uchar ADC_X(void)
{	uchar temp;
	LCD_CmdWrite(0x72);//TPXH	 X_coordinate high byte
	Chk_Busy();
	temp=LCD_DataRead();
	return temp;
}

uchar ADC_Y(void)
{	uchar temp;
	LCD_CmdWrite(0x73);//TPYH	  Y_coordinate high byte
	Chk_Busy();
	temp=LCD_DataRead();
	return temp;
}

uchar ADC_XY(void)
{	uchar temp;
 	LCD_CmdWrite(0x74);//TPXYL	  bit[3:2] Y_coordinate low byte  bit[1:0] X_coordinate low byte 
	temp=LCD_DataRead();
	return temp;
}   


// TP controller application function
void Access_TP_coordinate(void)	//
 {
  uint i;
  //Delay100ms(1);
  //TP_latch_X();//if manual mode
  //Delay10ms(1); //if  manual mode
  
 clear_TP_interrupt();
 Delay10ms(10);	 
 if(Touch_Status())
 {
   X2=0;
   X2|=ADC_X();
   i=(X2<<2);
   X2= i|((ADC_XY()&0x03));

  //Delay1ms(1);
  // TP_latch_Y();//if  manual mode
  // Delay10ms(1);//if manual mode
   Y2=0;
   Y2|=ADC_Y();
   i=(Y2<<2);
   Y2=i|((ADC_XY()>>2)&0x03);

  //TP_event_mode();//if manual mode

  clear_TP_interrupt(); 
  Delay10ms(1);
   if(Touch_Status())
      {
       X3=0;
       X3|=ADC_X();
       i=(X3<<2);
       X3= i|((ADC_XY()&0x03));	

       Y3=0;
       Y3|=ADC_Y();
       i=(Y3<<2);
       Y3=i|((ADC_XY()>>2)&0x03);

       clear_TP_interrupt();
       Delay10ms(1);
       if(Touch_Status())
        {
          X4=0;
          X4|=ADC_X();
          i=(X4<<2);
          X4= i|((ADC_XY()&0x03));	

          Y4=0;
          Y4|=ADC_Y();
          i=(Y4<<2);
          Y4=i|((ADC_XY()>>2)&0x03);

          MidValueCalculate();
          }
          else 
          {X1=0;Y1=0;X2=0;Y2=0;X3=0;Y3=0;X4=0;Y4=0;}
        }
     else
     {X1=0;Y1=0;X2=0;Y2=0;X3=0;Y3=0;X4=0;Y4=0;}
    }   
    else
     {X1=0;Y1=0;X2=0;Y2=0;X3=0;Y3=0;X4=0;Y4=0;}
 }

void Trace_coordinate (void)
{	  
      uchar temp;
	  uint temp1;
	  temp1=X1;
	  temp=(X1>>8);	  		
	  XY_Coordinate(100,60);  
	  Show_String("X = ");
	  Print_Hex(temp);			
	  temp=temp1;
	  Print_Hex(temp);
      Chk_Busy();

	  temp1=Y1;
	  temp=(Y1>>8);
	  XY_Coordinate(100, 140);   
	  LCD_CmdWrite(0x02);
	  Show_String("Y = ");
	  Print_Hex(temp);			
	  temp=temp1;
	  Print_Hex(temp);
	  Chk_Busy();

}	  

//==============================================================================
//Subroutine:	Show Hex	
//==============================================================================
void Print_Hex(uchar buf)
{
	uchar temp;
	temp=buf;
	temp = (temp >>4) & 0x0F;
	if(temp < 0x0A)
	{temp |= 0x30;
	}
	else temp = temp + 0x37;
	LCD_DataWrite(temp);
	Delay1ms(20);

	temp=buf;
	temp = temp & 0x0F;
	if(temp < 0x0A)
	{temp |= 0x30;
	}
	else temp = temp + 0x37;
	LCD_DataWrite(temp);
	Delay1ms(20);
}


void main(void)
{
ulong i;






   LCDMode_Reset();
   Delay100ms(1);
	LCD_Initial();
	Delay100ms(1);

	Display_ON(); 
 

	//=========================
	//PWMƱȹʾ
	//=========================
	PWM1_enable();
	PWM1_fnuction_sel();
	PWM1_clock_ratio(0x0f);
  //PWM1_duty_cycle(0x00); //


    //Delay100ms(5);//ʱʹʾ
    PWM1_duty_cycle(0x35); // 


//	Delay100ms(8);//ʱʹʾ
  //  PWM1_duty_cycle(0xff); //ȫ

	//Delay100ms(8);//ʱʹʾ

   

    


	//=========================
	//ȫˢʾ
	//=========================
   	Active_Window(20,180,60,190);	
	Clear_Full_Window();
	Memory_Clear_with_Font_BgColor();
	Text_Background_Color(0xe0);//ɫ
	Memory_Clear();	
    Chk_Busy(); 
	Delay100ms(5); //ʱʹʾ
	Clear_Active_Window();
	Text_Background_Color(0x1c);//ɫ
    Memory_Clear();	
    Delay100ms(5); //ʱʹʾ







	//==========================
	//ʾ濪رչʾ
	//=========================
	Display_OFF();
   Text_Background_Color(0x03);//ɫ
   Active_Window(30,200,50,100);
   Memory_Clear();	
    Delay100ms(5); //ʱʹʾ
   	Display_ON(); 





	//========================
	//д빦ʾ
	//========================
    Active_Window(50,129,50,129);
    XY_Coordinate(50,50);
    LCD_CmdWrite(0x02);//MRWC
	i=6400;  //80*80ص㣬64kɫĻ贫6400Σ͸λ͵λ 
	while(i--)
    {
    LCD_DataWrite(0x07);//ɫ:0x07e0
	Chk_Busy();
	LCD_DataWrite(0xe0);
	Chk_Busy();
	}
     Delay100ms(5); //ʱʹʾ
   XY_Coordinate(50,70);//ӹڵĿʼд
   i=4800;  //80*60ص㣬64kɫĻ贫4800Σ͸λ͵λ 
	LCD_CmdWrite(0x02);//MRWC
	while(i--)
    {
    LCD_DataWrite(0xff);//ɫ:0xffff
	Chk_Busy();
	LCD_DataWrite(0xff);
	Chk_Busy();
	}



   
    //=======================
    //ƾʾ
    //=======================
	Text_Background_Color(0xff);//ɫ
	Clear_Full_Window();
    Memory_Clear();	
    Delay100ms(5); //ʱʹʾ
    Active_Window(0,479,0,271);	
    Geometric_Coordinate(0,479,0,271); 
    Text_Foreground_Color(0x0f); //
    Draw_square();//ο
    Delay100ms(10); //ʱʹʾ
    Text_Foreground_Color(0x32); //
	Geometric_Coordinate(2,477,2,269);
	Draw_square_fill(); //




    //=======================
    //Բʾ
    //=======================
	 Chk_Busy();
     Circle_Coordinate_Radius(250,100,50);
     Text_Foreground_Color(0xef); //ۺɫ
	 Draw_circle();//Բ
     Delay100ms(10); //ʱʹʾ
	 Text_Foreground_Color(0xfe); //ɫ
	 Draw_circle_fill();//Բ
     Delay100ms(10); //ʱʹʾ





    //=====================
	//ֱʾ
	//====================
    Chk_Busy();
    Geometric_Coordinate(0,479,0,271); 
    Text_Foreground_Color(0xf0); 
    Draw_line();
    Delay100ms(10); //ʱʹʾ




 






	//=======================================================================
	//BTEʾ-ƶݣƵָλʾ
	//ע۲죺ƶԴڵʾʾĿ
	//=======================================================================
	//ʾݵ׼
	Clear_Full_Window();
     Memory_Clear();	
   //ʹþķʽɫ
    Geometric_Coordinate(0,479,0,34); 
    Text_Foreground_Color(0xE0); //ɫ
    Draw_square_fill(); 
    Chk_Busy();

    Geometric_Coordinate(0,479,34,68); 
    Text_Foreground_Color(0x03);//ɫ
    Draw_square_fill(); 
    Chk_Busy();

    Geometric_Coordinate(0,479,68,102); 
    Text_Foreground_Color(0x1c);
    Draw_square_fill(); //ɫ
    Chk_Busy();

    Geometric_Coordinate(0,479,102,136); 
    Text_Foreground_Color(0xe3);
    Draw_square_fill(); //ɫ
    Chk_Busy();

	Geometric_Coordinate(0,479,136,170); 
    Text_Foreground_Color(0x1f);//ǳ
    Draw_square_fill(); 
    Chk_Busy();

	Geometric_Coordinate(0,479,170,204); 
    Text_Foreground_Color(0xfc);//ɫ
    Draw_square_fill(); 
    Chk_Busy();

	Geometric_Coordinate(0,479,204,238); 
    Text_Foreground_Color(0x00);//ɫ 
    Draw_square_fill(); 
    Chk_Busy();

	Geometric_Coordinate(0,479,238,272); 
    Text_Foreground_Color(0xff);//	   
    Draw_square_fill(); 
    Chk_Busy();


   //任ɫͬԲ
    for(i=0;i<120;i++){
     Text_Foreground_Color(9*i); 
     Circle_Coordinate_Radius(120,136,i);
	 Draw_circle();//Բ
     Chk_Busy();
	 Text_Foreground_Color(30*i); 
     Circle_Coordinate_Radius(360,136,i);
     Draw_circle();//Բ
     Chk_Busy();
    }


    //ʼΪ00СΪ100*100ݣƵָλã240170ʾ
    BTE_Source_Destination(0,360,0,130);
    BTE_Size_setting(100,100);  
	BTE_ROP_Code(0xc2);// move BTE in positive  direction with ROP
	BTE_enable();
    Chk_Busy_BTE(); 
    Delay100ms(5); //ʱʹʾ

    BTE_Source_Destination(350,0,0,130);
    BTE_Size_setting(100,100);  
	BTE_ROP_Code(0xc2);// move BTE in positive  direction with ROP
	BTE_enable();
    Chk_Busy_BTE(); 
    Delay100ms(5); //ʱʹʾ









    //=======================================================================
	//BTEʾ-͸ƶݣ͸԰Ƶָλʾ
	//ע۲죺͸ƶᴩ͸ʾԴڵıɫ
	//=======================================================================
	//еʾʾ0xffɫ
    BTE_Source_Destination(350,200,0,5);
    BTE_Size_setting(100,100);  
	BTE_Foreground_red(0xff);//
	BTE_Foreground_green(0xff);//
    BTE_Foreground_blue(0xff);//
	BTE_ROP_Code(0xc5);
	BTE_enable();
    Chk_Busy_BTE();
    Delay100ms(5); //ʱʹʾ

    BTE_Source_Destination(0,200,0,130);
    BTE_Size_setting(100,100);  
	BTE_Foreground_red(0x00);//
	BTE_Foreground_green(0x00);//
    BTE_Foreground_blue(0xff);//
	BTE_ROP_Code(0xc5);
	BTE_enable();
    Chk_Busy_BTE();
    Delay100ms(5); //ʱʹʾ













	//==========================================
	//BTEɫ-ɫ书
	//ʾ100*1008
	//==========================================
	//Color_64K();
    
    Clear_Full_Window();
    Memory_Clear();	
	Chk_Busy(); 

	BTE_Source_Destination(0,5,0,5);
    BTE_Size_setting(104,100);
    BTE_Background_red(0x17);//64kɫʱbit[4:0]
	BTE_Background_green(0x2e);//64kɫʱbit[5:0]
  	BTE_Background_blue(0x08);//64kɫʱbit[4:0]
	BTE_Foreground_red(0x08);
	BTE_Foreground_green(0x11);
	BTE_Foreground_blue(0x17);
	BTE_ROP_Code(0x78); 
	BTE_enable();
    Delay100us(1);
	LCD_CmdWrite(0x02);//MRWC
    for(i=0;i<1300;i++)
    {LCD_DataWrite(gImage_8[i]);	 
	 Chk_Busy();}   		
   




	 //===================
	 //ʾ
	 //===================
     Scroll_Window(5,108,5,104);	//ָҪĻ
	  i=0; 
	 while(i++<99){Delay10ms(1); Scroll_Offset(i,i);} //ע⣺ƫֵСھ趨Χ
     while(i-->0){Delay10ms(1); Scroll_Offset(i,i);}  
     
	 while(i++<99){Delay10ms(1); Scroll_Offset(i,i);}
     while(i-->0){Delay10ms(1); Scroll_Offset(i,i);}

	 





	 //============================
	 //ʾ8*16 dots ASCII ʾ
	 //============================
    Text_Mode();
	ASCII_Mode_enable();
	Text_Foreground_Color(0x03);//ɫ
    Text_Background_Color(0xff);//ɫ
    //Active_Window(109,319,0,239);	
	XY_Coordinate(0,105);
	LCD_CmdWrite(0x02);
	for(i=0;i<256;i++)
	{
	 LCD_DataWrite(i);
     Chk_Busy();
	 }

	 Delay100ms(5); //ʱʹʾ

    







	 //==================================
	 //ʾ16*16 dots ʾ
	 //==================================
	ASCII_Mode_disable();
   	External_CGROM();
	//ʾ
    External_CGROM_GB();
	//Active_Window(5,108,105,239);	
    XY_Coordinate(5,160); 
	Text_Foreground_Color(0xe0);//ɫ
	Show_String("OCM480272T430-1Bʾʱ׼ISO8859-1/2/3/4ͣ256*4ʾ󲿷ʹӢϵŷ޹ҵİĸšͼεĵʹϣOCM480272T430-1B֧һ2DBTE,BTEһͨõ2D BitBLTĹܣڴͼתOCM480272T430-1BһЩǿͼδܣ续תܡܡַŴȵȣMCUִЧʡ");

	
	
   

	//ʾ
	External_CGROM_BIG5();
	XY_Coordinate(205,0); 
    Show_String("Pql");//ʾ


















	 //============================
	 //ʾģʽʾ
	 //============================
	 //90ת
	// Color_256();
	 XY_Coordinate(110,0); 
	 ASCII_Mode_enable();
	 Internal_CGROM();
	 Text_Foreground_Color(0xff);//ɫ
     Text_Background_Color(0x03);//ɫ
     Rotate90_Font();
	 Show_String("McDonald's");

	 NoRotate_Font();

	 Delay100ms(5); //ʱʹʾ



     //ּӴ
	 Bold_Font();
	 Show_String("McDonald's");

	 NoBold_Font();//رּӴֹ
	 Delay100ms(5); //ʱʹʾ




      

	 //ˮƽ򡢴ֱ򶼷Ŵ3,ͬʱ͸
     XY_Coordinate(0,0); 
	 Text_Foreground_Color(0x6f);//
	 Horizontal_FontEnlarge_x3();
     Vertical_FontEnlarge_x3();
     Font_with_BackgroundTransparency();
	 ASCII_Mode_disable();
   	 External_CGROM();
	 External_CGROM_GB();
	 Show_String("");


	 //رմ͸ʾһ
     XY_Coordinate(0,50); 
	 Font_with_BackgroundColor();
	 Show_String("");






	
	



     //========================
     //ͼ͹깦ʾ
     //========================
    Graphic_Cursor_Color_0(0x00); 
    Graphic_Cursor_Color_1(0xff); 
    Write_To_GraphicCursor();
    Graphic_Cursor_Set1();
   	Graphic_Mode();
    LCD_CmdWrite(0x02);//MRWC

    for(i=0;i<256;i++)
    {
    LCD_DataWrite(gImage_wait_l[i]);
    Chk_Busy();
    }

	Graphic_Cursor_Coordinate(0,0);	
	Graphic_Cursor();  

    for(i=0;i<256;i++)
	{
    Delay10ms(1); //ʱʹʾ
	Graphic_Cursor_Coordinate(2*i,i);	
	}


	Delay100ms(1); //ʱʹʾ

	No_Graphic_Cursor();
	Write_To_Bank1and2();

    Chk_Busy(); 






    
     //========================
     //ʾ
     //========================
     //Դгʼ
	 //---------TP initial ----
	Enable_TP();
	LCD_CmdWrite(0x70);//set TP sample time  & ADC clock 
	LCD_DataWrite(0xb2);
	Set_4wire_TP();
	TP_auto_mode(); //enable auto mode 
	//TP_manual_mode();
	enable_TP_interrupt();// demo code using Auto mode + polling 8Fh to confirm touch
    
	Text_Mode();
	Memory_Clear();	
	Chk_Busy(); 
   
     Text_Foreground_Color(0xff);//ɫɫ

	 while(1)
	 {
       clear_TP_interrupt();
       Delay10ms(5);
       if(Touch_Status())
       {
       Access_TP_coordinate();
       Trace_coordinate ();
       }
	   else
	   {
   	   X1=0;Y1=0;
       Trace_coordinate ();
	  }
     Delay10ms(10);
	}					


    





while(1);


}



