/*******************************************************************************
RA8875 by Mountain
*******************************************************************************/
#include <intrins.h>
#include "delay.h"

#define uchar unsigned char
#define uint unsigned int
#define ushort unsigned short
#define ulong unsigned long
//------------------------------------------------------------------------------
//Parameter Defines
//------------------------------------------------------------------------------

void Delay1us(void)
{

 Delay2us(1);

}

//==============================================================================
//Subroutine:	Delay2us
//==============================================================================
void Delay2us(uchar Counter)
{

	while(--Counter);
}

//==============================================================================
//Subroutine:	Delay100us
//==============================================================================
void Delay100us(uchar Counter)
{
	while(Counter--)
	{	Delay2us(100);
	}
}

//==============================================================================
//Subroutine:	Delay1ms
//==============================================================================
void Delay1ms(uchar Counter)
{
	while(Counter--)
	{	Delay100us(11);			
	}
}

//==============================================================================
//Subroutine:	Delay10ms
//==============================================================================
void Delay10ms(uchar Counter)
{
	while(Counter--)
	{	Delay1ms(11);			
	}
}  

//==============================================================================
//Subroutine:	Delay100ms
//==============================================================================
void Delay100ms(uchar Counter)
{
	while(Counter--)
	{	Delay1ms(101);			
	}
}
