#ifndef _52_Driver_H
#define _52_Driver_H

#include <reg52.h>


typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned short ushort;
typedef unsigned long ulong;


#define uint16 unsigned short int

#define	cSetD0		     0x01
#define	cSetD1		     0x02
#define	cSetD2		     0x04
#define	cSetD3		     0x08
#define	cSetD4		     0x10
#define	cSetD5		     0x20
#define	cSetD6		     0x40
#define	cSetD7		     0x80

#define	cClrD0		     0xfe
#define	cClrD1		     0xfd
#define	cClrD2		     0xfb
#define	cClrD3		     0xf7
#define	cClrD4		     0xef
#define	cClrD5		     0xdf
#define	cClrD6		     0xbf
#define	cClrD7		     0x7f

#define cClrD1D0         0xfc
#define cClrD1SetD0	     0x01
#define cSetD1ClrD0	     0x02
#define cSetD1D0		 0x03
#define cClrD3D2         0xf3
#define cClrD3SetD2      0x04
#define cSetD3ClrD2      0x08
#define cSetD3D2		 0x0c

//#define cClrD2D1D0		 0xf8
//#define cClrD2D1SetD0	 0x01
//#define cClrD2SetD1ClrD0 0x02
//#define cClrD2SetD1D0	 0x03
//#define cSetD2ClrD1D0	 0x04
//#define cSetD2ClrD1SetD0 0x05

#define cClrD6D5D4	     0x8f
//#define cClrD6D5SetD4    0x10
//#define cClrD6SetD5ClrD4 0x20
//#define cClrD6SetD5D4	 0x30
//#define cSetD6ClrD5D4	 0x40
//#define cSetD6ClrD5SetD4 0x50
//#define cSetD6D5ClrD4	 0x60
//#define cSetD6D5D4		 0x70

void Delay2us(uchar Counter);
void Delay100us(uchar Counter);
void Delay1ms(uchar Counter);
void Delay10ms(uchar Counter);
void Delay100ms(uchar Counter);

void LCD_CmdWrite(uchar cmd);
uchar LCD_CmdRead(void);
void LCD_DataWrite(uchar Data);
uchar LCD_StatusRead(void);
uchar LCD_DataRead(void);
void Chk_Busy(void);
void LCDMode_Reset(void);

#endif